<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.20"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<a class="dashingAutolink" name="autolink-125"></a><a class="dashAnchor" name="//apple_ref/cpp/Package/XHXKit%3A%20%2FUsers%2Fscar1900%2FDeveloper%2FXHXKit%2FXHXKit%2FClasses%2FGeneral%2FCategory%2FNSString%2BKOExtension.m%20%E6%BA%90%E6%96%87%E4%BB%B6"></a><title>XHXKit: /Users/scar1900/Developer/XHXKit/XHXKit/Classes/General/Category/NSString+KOExtension.m 源文件</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">XHXKit
   &nbsp;<span id="projectnumber">4.10.0.12</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- 制作者 Doxygen 1.8.20 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'搜索');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','搜索');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow" onmouseover="return searchBox.OnSearchSelectShow()" onmouseout="return searchBox.OnSearchSelectHide()" onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d522931ffa1371640980b621734a4381.html">Users</a></li><li class="navelem"><a class="el" href="dir_2f48480e0fdb0436fb8fd57a1ed5f613.html">scar1900</a></li><li class="navelem"><a class="el" href="dir_c8b33409012acfc781ba898892fd3b4c.html">Developer</a></li><li class="navelem"><a class="el" href="dir_0e1030ab80149b7e8d6dfd17946e9c40.html">XHXKit</a></li><li class="navelem"><a class="el" href="dir_c9ece41fcb3917ec137dcec44cd0055f.html">XHXKit</a></li><li class="navelem"><a class="el" href="dir_3a9521ad7c4429598be7e28fa39d3d14.html">Classes</a></li><li class="navelem"><a class="el" href="dir_3d53dd88e59abdcd55a12c7e475393fb.html">General</a></li><li class="navelem"><a class="el" href="dir_6aab43a226a6a6887d476b2e5d48e49d.html">Category</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">NSString+KOExtension.m</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_n_s_string_09_k_o_extension_8m.html">浏览该文件的文档.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno"><a class="line" href="category_n_s_string_07_k_o_extension_08.html#aaae452f4bc1e18a9487b4801f6a40e6c">    1</a></span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&nbsp;<span class="comment">//  NSString+KOExtension.m</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&nbsp;<span class="comment">//  KKLOnLine</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&nbsp;<span class="comment">//  Created by 江俊辰 on 2017/6/19.</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&nbsp;<span class="comment">//  Copyright &copy; 2017年 mistong. All rights reserved.</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&nbsp; </div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&nbsp;<span class="preprocessor">#import &#34;<a class="code" href="_n_s_string_09_k_o_extension_8h.html">NSString+KOExtension.h</a>&#34;</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&nbsp; </div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&nbsp;<span class="keyword">@implementation </span><a class="code" href="category_n_s_string_07_k_o_extension_08.html">NSString (KOExtension)</a></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&nbsp; </div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&nbsp;- (BOOL)hasSubString:(NSString *)subString {</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&nbsp;    <span class="keywordflow">if</span> (!subString || subString.length == 0) {</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&nbsp;        <span class="keywordflow">return</span> NO;</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&nbsp;    }</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&nbsp;    <span class="keywordflow">return</span> [<span class="keyword">self</span> rangeOfString:subString].location != NSNotFound;        </div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&nbsp;}</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&nbsp; </div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&nbsp;- (CGSize)sizeWithWidth:(CGFloat)width font:(UIFont *)font {</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&nbsp;    CGSize maxSize = CGSizeMake(width, 9999);</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&nbsp;    CGSize expectedSize;</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&nbsp;    </div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&nbsp;    NSDictionary *attribute = [NSDictionary dictionaryWithObjectsAndKeys:font,NSFontAttributeName, nil];</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&nbsp;    NSStringDrawingOptions options = NSStringDrawingUsesLineFragmentOrigin | NSStringDrawingUsesFontLeading;</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&nbsp;    expectedSize = [<span class="keyword">self</span> boundingRectWithSize:maxSize options:options attributes:attribute context:nil].size;</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&nbsp;    </div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&nbsp;    <span class="keywordflow">return</span> expectedSize;</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&nbsp;}</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&nbsp;- (BOOL)<a class="code" href="category_n_s_string_07_k_o_extension_08.html#aedb6c7de0cc77da8301cf231f418e277">checkPhoneNumInput</a> {</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&nbsp;    <span class="comment">//匹配信息</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&nbsp;    NSString *regex = [NSString phoneNumRegexp];</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&nbsp;    NSPredicate *pred = [NSPredicate predicateWithFormat:@&#34;SELF MATCHES %@&#34;, regex];</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&nbsp;    <span class="keywordflow">return</span> [pred evaluateWithObject:self];</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&nbsp;}</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&nbsp; </div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&nbsp;<span class="comment">//电话号码的正则匹配</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&nbsp;+ (NSString *)<a class="code" href="category_n_s_string_07_k_o_extension_08.html#a5ef58fa08f5fde820f1ec562f4f86c12">phoneNumRegexp</a> {</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&nbsp;    <span class="keywordflow">return</span> <span class="stringliteral">@&#34;^\\d{11}$&#34;</span>;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&nbsp;}</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&nbsp; </div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&nbsp;- (BOOL)<a class="code" href="category_n_s_string_07_k_o_extension_08.html#aa54b4c7ca3025244bd580caff66ff236">isChinese</a></div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&nbsp;{</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&nbsp;    NSString *match = <span class="stringliteral">@&#34;(^[\u4e00-\u9fa5]+$)&#34;</span>;</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&nbsp;    NSPredicate *predicate = [NSPredicate predicateWithFormat:@&#34;SELF matches %@&#34;, match];</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&nbsp;    <span class="keywordflow">return</span> [predicate evaluateWithObject:self];</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&nbsp;}</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&nbsp; </div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&nbsp;- (BOOL)<a class="code" href="category_n_s_string_07_k_o_extension_08.html#a827efdb04766f1a3899f5082ee491379">includeChinese</a></div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&nbsp;{</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&nbsp;    <span class="keywordflow">for</span>(<span class="keywordtype">int</span> i=0; i&lt; [<span class="keyword">self</span> length];i++)</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&nbsp;    {</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&nbsp;        <span class="keywordtype">int</span> a =[<span class="keyword">self</span> characterAtIndex:i];</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&nbsp;        <span class="keywordflow">if</span>( a &gt;0x4e00 &amp;&amp; a &lt;0x9fff){</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&nbsp;            <span class="keywordflow">return</span> YES;</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&nbsp;        }</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&nbsp;    }</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&nbsp;    <span class="keywordflow">return</span> NO;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&nbsp;}</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&nbsp;<span class="comment">//判断字符串是否有空格</span></div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&nbsp;- (BOOL)<a class="code" href="category_n_s_string_07_k_o_extension_08.html#ab5147695ef936e19b2e0bd527f31f644">isHaveEmptyString</a> {</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&nbsp;    NSRange range = [<span class="keyword">self</span> rangeOfString:@&#34; &#34;];</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&nbsp;    <span class="keywordflow">if</span> (range.location != NSNotFound) {</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&nbsp;        return YES;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&nbsp;    } <span class="keywordflow">else</span> {</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&nbsp;        return NO;</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&nbsp;    }</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&nbsp;}</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&nbsp;<span class="comment">//判断字符串是否有换行符</span></div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&nbsp;- (BOOL)<a class="code" href="category_n_s_string_07_k_o_extension_08.html#ad448bc6cedc3dd363590d877f47eb455">isHaveNewlineString</a> {</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&nbsp;    NSRange range = [<span class="keyword">self</span> rangeOfString:@&#34;\n&#34;];</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&nbsp;    <span class="keywordflow">if</span> (range.location != NSNotFound) {</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&nbsp;        return YES;</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&nbsp;    } <span class="keywordflow">else</span> {</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&nbsp;        return NO;</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&nbsp;    }</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&nbsp;}</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&nbsp;- (BOOL)<a class="code" href="category_n_s_string_07_k_o_extension_08.html#a842aca59fb1dfbb8a767b68e2c262586">isNumber</a></div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&nbsp;{</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&nbsp;    NSString *regex = <span class="stringliteral">@&#34;[0-9]*&#34;</span>;</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&nbsp;    NSPredicate *pred = [NSPredicate predicateWithFormat:@&#34;SELF MATCHES %@&#34;,regex];</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&nbsp;    <span class="keywordflow">return</span> [pred evaluateWithObject:self];</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&nbsp;}</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&nbsp; </div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&nbsp;<span class="keyword">@end</span></div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="acategory_n_s_string_07_k_o_extension_08_html_a5ef58fa08f5fde820f1ec562f4f86c12"><div class="ttname"><a href="category_n_s_string_07_k_o_extension_08.html#a5ef58fa08f5fde820f1ec562f4f86c12">+[NSString(KOExtension) phoneNumRegexp]</a></div><div class="ttdeci">NSString * phoneNumRegexp()</div><div class="ttdef"><b>Definition:</b> <a href="_n_s_string_09_k_o_extension_8m_source.html#l00001">NSString+KOExtension.m:38</a></div></div>
<div class="ttc" id="acategory_n_s_string_07_k_o_extension_08_html_ab5147695ef936e19b2e0bd527f31f644"><div class="ttname"><a href="category_n_s_string_07_k_o_extension_08.html#ab5147695ef936e19b2e0bd527f31f644">-[NSString(KOExtension) isHaveEmptyString]</a></div><div class="ttdeci">BOOL isHaveEmptyString()</div><div class="ttdef"><b>Definition:</b> <a href="_n_s_string_09_k_o_extension_8m_source.html#l00001">NSString+KOExtension.m:61</a></div></div>
<div class="ttc" id="acategory_n_s_string_07_k_o_extension_08_html_a842aca59fb1dfbb8a767b68e2c262586"><div class="ttname"><a href="category_n_s_string_07_k_o_extension_08.html#a842aca59fb1dfbb8a767b68e2c262586">-[NSString(KOExtension) isNumber]</a></div><div class="ttdeci">BOOL isNumber()</div><div class="ttdef"><b>Definition:</b> <a href="_n_s_string_09_k_o_extension_8m_source.html#l00001">NSString+KOExtension.m:78</a></div></div>
<div class="ttc" id="acategory_n_s_string_07_k_o_extension_08_html_ad448bc6cedc3dd363590d877f47eb455"><div class="ttname"><a href="category_n_s_string_07_k_o_extension_08.html#ad448bc6cedc3dd363590d877f47eb455">-[NSString(KOExtension) isHaveNewlineString]</a></div><div class="ttdeci">BOOL isHaveNewlineString()</div><div class="ttdef"><b>Definition:</b> <a href="_n_s_string_09_k_o_extension_8m_source.html#l00001">NSString+KOExtension.m:70</a></div></div>
<div class="ttc" id="a_n_s_string_09_k_o_extension_8h_html"><div class="ttname"><a href="_n_s_string_09_k_o_extension_8h.html">NSString+KOExtension.h</a></div></div>
<div class="ttc" id="acategory_n_s_string_07_k_o_extension_08_html_aa54b4c7ca3025244bd580caff66ff236"><div class="ttname"><a href="category_n_s_string_07_k_o_extension_08.html#aa54b4c7ca3025244bd580caff66ff236">-[NSString(KOExtension) isChinese]</a></div><div class="ttdeci">BOOL isChinese()</div><div class="ttdef"><b>Definition:</b> <a href="_n_s_string_09_k_o_extension_8m_source.html#l00001">NSString+KOExtension.m:42</a></div></div>
<div class="ttc" id="acategory_n_s_string_07_k_o_extension_08_html_aedb6c7de0cc77da8301cf231f418e277"><div class="ttname"><a href="category_n_s_string_07_k_o_extension_08.html#aedb6c7de0cc77da8301cf231f418e277">-[NSString(KOExtension) checkPhoneNumInput]</a></div><div class="ttdeci">BOOL checkPhoneNumInput()</div><div class="ttdef"><b>Definition:</b> <a href="_n_s_string_09_k_o_extension_8m_source.html#l00001">NSString+KOExtension.m:30</a></div></div>
<div class="ttc" id="acategory_n_s_string_07_k_o_extension_08_html_a827efdb04766f1a3899f5082ee491379"><div class="ttname"><a href="category_n_s_string_07_k_o_extension_08.html#a827efdb04766f1a3899f5082ee491379">-[NSString(KOExtension) includeChinese]</a></div><div class="ttdeci">BOOL includeChinese()</div><div class="ttdef"><b>Definition:</b> <a href="_n_s_string_09_k_o_extension_8m_source.html#l00001">NSString+KOExtension.m:49</a></div></div>
<div class="ttc" id="acategory_n_s_string_07_k_o_extension_08_html"><div class="ttname"><a href="category_n_s_string_07_k_o_extension_08.html">NSString(KOExtension)</a></div><div class="ttdef"><b>Definition:</b> <a href="_n_s_string_09_k_o_extension_8h_source.html#l00011">NSString+KOExtension.h:11</a></div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
制作者&nbsp;<a href="http://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.8.20
</small></address>


</body></html>